summaryrefslogtreecommitdiffstats
path: root/bin/git-repo-repack
diff options
context:
space:
mode:
Diffstat (limited to 'bin/git-repo-repack')
-rwxr-xr-xbin/git-repo-repack45
1 files changed, 45 insertions, 0 deletions
diff --git a/bin/git-repo-repack b/bin/git-repo-repack
new file mode 100755
index 0000000..9e733d2
--- /dev/null
+++ b/bin/git-repo-repack
@@ -0,0 +1,45 @@
+#!/bin/sh
+
+set -e
+
+case "${1}" in
+ --quiet)
+ QUIET="true"
+ shift
+
+ GIT_REPACK_OPTIONS="-q"
+ GIT_GC_OPTIONS="--quiet"
+ ;;
+esac
+
+REPOSITORIES="${@}"
+
+if [ -z "${REPOSITORIES}" ]
+then
+ if [ ! -e HEAD ]
+ then
+ REPOSITORIES="*.git"
+ else
+ REPOSITORIES="$(pwd)"
+ fi
+fi
+
+for REPOSITORY in ${REPOSITORIES}
+do
+ [ "${QUIET}" ] || echo "--------------------------------------------------------------------------------"
+ [ "${QUIET}" ] || echo ${REPOSITORY}
+ [ "${QUIET}" ] || echo "--------------------------------------------------------------------------------"
+
+ cd "${REPOSITORY}"
+ git repack ${GIT_REPACK_OPTIONS} -a -b -d -f -F
+ git gc ${GIT_GC_OPTIONS} --aggressive --prune
+ cd "${OLDPWD}"
+
+ if [ "$(id -u)" -eq "0" ]
+ then
+ UID="$(stat -c %u ${REPOSITORY})"
+ GID="$(stat -c %g ${REPOSITORY})"
+
+ chown ${UID}:${GID} "${REPOSITORY}" -R
+ fi
+done